/* ====================================
		INIo
==================================== */
#include "stdafx.h"
#include "ClrChker.h"


/* ====================================
		錾
==================================== */
extern CPathSpliter splt;
extern CRGBCalc     rgbObj;
extern CMDIWindow   mdiObj;

//ÓIoϐ̏
TCHAR  CPrivateINICtrl::iniPath[]          = TEXT("");	//LoadAllŒgĂ
LPTSTR CPrivateINICtrl::wndSec             = TEXT("MAINWINDOW");
LPTSTR CPrivateINICtrl::wndKeyPos          = TEXT("POSITION");
LPTSTR CPrivateINICtrl::wndKeyPage         = TEXT("PAGE");
LPTSTR CPrivateINICtrl::optSec             = TEXT("MENU");
LPTSTR CPrivateINICtrl::menuKeyAUTOCOPY    = TEXT("AUTOCOPY");
LPTSTR CPrivateINICtrl::menuKeyCAPTION     = TEXT("CAPTION");
LPTSTR CPrivateINICtrl::menuKeyTOPLEVEL    = TEXT("TOPLEVEL");
LPTSTR CPrivateINICtrl::menuKeySYNCHRO     = TEXT("SYNCHRO");
LPTSTR CPrivateINICtrl::ctrlKeySAFESLIDE   = TEXT("SAFESLIDE");
int    CPrivateINICtrl::idAUTOCOPY         = IDM_AUTOCOPY;
int    CPrivateINICtrl::idCAPTION          = IDM_CAPTION;
int    CPrivateINICtrl::idTOPLEVEL         = IDM_TOPLEVEL;
int    CPrivateINICtrl::idSYNCHRO          = IDM_SYNCHRO;
int    CPrivateINICtrl::idSAFESLIDE        = IDC_CHECKBOX1068;
LPTSTR CPrivateINICtrl::mdiSec             = TEXT("MDIWINDOW");
LPTSTR CPrivateINICtrl::mdiKeyPos          = TEXT("RECT");
LPTSTR CPrivateINICtrl::prevSec            = TEXT("PREVIEW");
LPTSTR CPrivateINICtrl::prevKeyEditStr     = TEXT("STRING");
LPTSTR CPrivateINICtrl::prevKeyEditClr     = TEXT("EDITCLR");
LPTSTR CPrivateINICtrl::prevKeyStaticClr   = TEXT("BACKCLR");
LPTSTR CPrivateINICtrl::prevKeyFontClr     = TEXT("FONTCLR");
LPTSTR CPrivateINICtrl::prevKeyFontFace    = TEXT("FONTFACE");
LPTSTR CPrivateINICtrl::prevKeyFontHeight  = TEXT("FONTHEIGHT");
LPTSTR CPrivateINICtrl::prevKeyFontOption  = TEXT("FONTOPTION");
LPTSTR CPrivateINICtrl::prevKeyFontCharset = TEXT("FONTCHARSET");


/* ====================================
		`
==================================== */
//CPrivateINICtrl - I[o[[hꂽAo͓sRXgN^
//hwnd     : in  : enh
//prev     : in  : vr[ɊւIuWFNg prev ւ̎Q
//saveFlag : in  : 0=Load | 1=Save
CPrivateINICtrl::CPrivateINICtrl(HWND hwnd, CRGBCalc &calcObj, bool saveFlag) {
	if (saveFlag) {
		SaveAll(hwnd);
	} else {
		LoadAll(hwnd, calcObj);
	}
}

//CPrivateINICtrl - ׂĂINIt@Cɏo͂
//    return : MDIqAۑȂ^AqƂ͋U
//hwnd : in  : enh
bool CPrivateINICtrl::SaveAll(HWND hwnd) {
	HMENU hSubMenu = _GetSubMenu(GetMenu(hwnd), 1);

	//eʒu
	if (IsZoomed(hwnd)) {
		lstrcpy(iniData, TEXT("MAX"));
	} else if (IsIconic(hwnd)) {
		lstrcpy(iniData, TEXT("MIN"));
	} else {
		RECT rc;
		GetWindowRect(hwnd, &rc);
		wsprintf(iniData, TEXT("%d,%d,%d,%d"), rc.left, rc.top, rc.right, rc.bottom);
	}
	WritePrivateProfileString(wndSec, wndKeyPos, iniData, iniPath);
	//\^u
	WritePrivateProfileString(wndSec, wndKeyPage, ToString(TabCtrl_GetCurSel(GetDlgItem(hwnd, IDC_TABCONTROL1028))), iniPath);

	//Nbv{[hփRs[
	WritePrivateProfileString(optSec, menuKeyAUTOCOPY, ToString(GetMenuState(hSubMenu, idAUTOCOPY, MF_BYCOMMAND)), iniPath);
  //啶ŏo
  WritePrivateProfileString(optSec, menuKeyCAPTION, ToString(GetMenuState(hSubMenu, idCAPTION, MF_BYCOMMAND)), iniPath);
	//ɎO
  WritePrivateProfileString(optSec, menuKeyTOPLEVEL, ToString(GetMenuState(hSubMenu, idTOPLEVEL, MF_BYCOMMAND)), iniPath);
	//F̓
  WritePrivateProfileString(optSec, menuKeySYNCHRO, ToString(GetMenuState(hSubMenu, idSYNCHRO, MF_BYCOMMAND)), iniPath);
	//Z[tJ[XCh(j[Ȃł
	WritePrivateProfileString(optSec, ctrlKeySAFESLIDE, ToString(SendDlgItemMessage(hwnd, this->idSAFESLIDE, BM_GETCHECK, 0, 0)), iniPath);

	//q̏擾łȂꍇ͂ŏI
	if (!mdiObj.GetActChildHandle()) { return false; }

	SaveMDIChild(mdiObj.GetActChildHandle());
	return true;
}

//CPrivateINICtrl - MDIqɊւINIt@Cɏo͂
//hMDIChild : in  : 悤ƂĂMDIqnh
void CPrivateINICtrl::SaveMDIChild(HWND hMDIChild) {
	int cnt;
	LPPREVIEW lpPrev = (LPPREVIEW)GetWindowLongPtr(hMDIChild, GWLP_USERDATA);

	//qʒu(MDINCAg̑΍W
	if (IsZoomed(hMDIChild)) {
		lstrcpy(iniData, TEXT("MAX"));
	} else if (IsIconic(hMDIChild)) {
		lstrcpy(iniData, TEXT("MIN"));
	} else {
		RECT rc;
		POINT po;
		po.x = po.y = 0;
		GetWindowRect(hMDIChild, &rc);
		ClientToScreen(mdiObj.GetClientHandle(), &po);
		wsprintf(iniData, TEXT("%d,%d,%d,%d"),
			rc.left-po.x, rc.top-po.y, rc.right-rc.left, rc.bottom-rc.top);
	}
	WritePrivateProfileString(mdiSec, mdiKeyPos, iniData, iniPath);

	//edit string
	cnt = GetWindowText(lpPrev->hEdit, iniData, sizeof(iniData));
	for (int i=0 ; i<cnt ; i++) {
		if (iniData[i] == '\r' || iniData[i] == '\n') { iniData[i]='\\'; }
	}
	WritePrivateProfileString(prevSec, prevKeyEditStr, iniData, iniPath);
	//edit color
	WritePrivateProfileString(prevSec, prevKeyEditClr, ToString(lpPrev->editRGB), iniPath);
	//static color
	WritePrivateProfileString(prevSec, prevKeyStaticClr, ToString(lpPrev->backRGB), iniPath);
	//font color
	WritePrivateProfileString(prevSec, prevKeyFontClr, ToString(lpPrev->fontRGB), iniPath);
	//font face
	WritePrivateProfileString(prevSec, prevKeyFontFace, lpPrev->fontSty.lfFaceName, iniPath);
	//font point
	WritePrivateProfileString(prevSec, prevKeyFontHeight, ToString(lpPrev->fontSty.lfHeight), iniPath);
	//font option
	cnt = 0;
	if (lpPrev->fontSty.lfWeight == FW_BOLD) { cnt += 1; }
	if (lpPrev->fontSty.lfItalic)    { cnt += 2; }
	if (lpPrev->fontSty.lfUnderline) { cnt += 4; }
	if (lpPrev->fontSty.lfStrikeOut) { cnt += 8; }
	WritePrivateProfileString(prevSec, prevKeyFontOption, ToString(cnt), iniPath);
	//font charset
	WritePrivateProfileString(prevSec, prevKeyFontCharset, ToString(lpPrev->fontSty.lfCharSet), iniPath);
}

//CPrivateINICtrl - INIt@CǂݍݓKp
//    return : sK^Ԃ(sUƂɂĂ
//prev : in  : vr[ɊւIuWFNg prev ւ̎Q
//hnwd : in  : enh
bool CPrivateINICtrl::LoadAll(HWND hwnd, CRGBCalc &calcObj) {
	int    iniInt;
	LPTSTR ret;
	HMENU  hSubMenu = _GetSubMenu(GetMenu(hwnd), 1);

	lstrcpy(iniPath, splt.GetSplitPath(__targv[0], 14));
	lstrcat(iniPath, TEXT(".ini"));										//INIpX

	//TCY
	GetPrivateProfileString(wndSec, wndKeyPos, TEXT(""), iniData, sizeof(iniData), iniPath);
	if (!lstrcmp(iniData, TEXT("MAX"))) {
		PostMessage(hwnd, WM_SYSCOMMAND, SC_MAXIMIZE, 0);		//ő剻L[ɏ悹
	} else if (!lstrcmp(iniData, TEXT("MIN"))) {
		PostMessage(hwnd, WM_SYSCOMMAND, SC_MINIMIZE, 0);		//ŏL[ɏ悹
	} else {
		int rect[] = {0, 0, 0, 0};													//lw
		LPTSTR next, ret = _tcstok_s(iniData, TEXT(","), &next);
		for (int i=0 ; i<4 ; i++) {
			if (ret == NULL) { break; }		//INI̓eُȏꍇ͂Œ~
			rect[i] = _ttoi(ret);
			ret = _tcstok_s(NULL, TEXT(","), &next);
		}
		if (rect[3]) { MoveWindow(hwnd, rect[0], rect[1], rect[2]-rect[0], rect[3]-rect[1], FALSE);	}
	}
	//\^u
	iniInt = GetPrivateProfileInt(wndSec, wndKeyPage, 0, iniPath);
	SendMessage(GetDlgItem(hwnd, IDC_TABCONTROL1028), TCM_SETCURSEL, /* page */iniInt, 0);

  //Nbv{[hփRs[
	iniInt = GetPrivateProfileInt(optSec, menuKeyAUTOCOPY, MF_UNCHECKED, iniPath);
	CheckMenuItem(hSubMenu, idAUTOCOPY, MF_BYCOMMAND | (iniInt == MF_UNCHECKED) ? MF_UNCHECKED : MF_CHECKED);
  //啶ŏo
	iniInt = GetPrivateProfileInt(optSec, menuKeyCAPTION, MF_CHECKED, iniPath);
	CheckMenuItem(hSubMenu, idCAPTION, MF_BYCOMMAND | (iniInt == MF_UNCHECKED) ? MF_UNCHECKED : MF_CHECKED);
  //ɎO
	iniInt = GetPrivateProfileInt(optSec, menuKeyTOPLEVEL, MF_UNCHECKED, iniPath);
	CheckMenuItem(hSubMenu, idTOPLEVEL, MF_BYCOMMAND | (iniInt == MF_UNCHECKED) ? MF_UNCHECKED : MF_CHECKED);
  //F̓
	iniInt = GetPrivateProfileInt(optSec, menuKeySYNCHRO, MF_CHECKED, iniPath);
	CheckMenuItem(hSubMenu, idSYNCHRO, MF_BYCOMMAND | (iniInt == MF_UNCHECKED) ? MF_UNCHECKED : MF_CHECKED);
  //Z[tXCh
	iniInt = GetPrivateProfileInt(optSec, ctrlKeySAFESLIDE, BST_UNCHECKED, iniPath);
	SendDlgItemMessage(hwnd, idSAFESLIDE, BM_SETCHECK, (WPARAM)iniInt, 0);

	//qʒu(MDINCAg̑΍W
	GetPrivateProfileString(mdiSec, mdiKeyPos, TEXT(""), iniData, 1024, iniPath);
	if (!lstrcmp(iniData, TEXT("MAX"))) {
		SendMessage(mdiObj.GetClientHandle(), WM_MDIMAXIMIZE, (WPARAM)mdiObj.GetActChildHandle(), 0);
	} else if (!lstrcmp(iniData, TEXT("MIN"))) {
		PostMessage(mdiObj.GetActChildHandle(), WM_SYSCOMMAND, SC_MINIMIZE, 0);	//L[ɂȂCREATETCY̍ŏȂ̂ňʒu
	} else {
		int rect[] = {0, 0, 0, 0};													//lw
		LPTSTR next, ret = _tcstok_s(iniData, TEXT(","), &next);
		for (int i=0 ; i<4 ; i++) {
			if (ret == NULL) { break; }		//INI̓eُȏꍇ͂Œ~
			rect[i] = _ttoi(ret);
			ret = _tcstok_s(NULL, TEXT(","), &next);
		}
		if (rect[3]) { MoveWindow(mdiObj.GetActChildHandle(), rect[0], rect[1], rect[2], rect[3], FALSE);	}
	}

	//edit string
	GetPrivateProfileString(prevSec, prevKeyEditStr, TEXT("ެݸ"), iniData, sizeof(iniData), iniPath);
	ret = _tcsstr(iniData, TEXT("\\\\"));
	while(ret != NULL) {
		ret[0] = '\r';
		ret[1] = '\n';
		ret = _tcsstr(iniData, TEXT("\\\\"));
	};
	SendMessage(mdiObj.GetActChildHandle(), WM_APP_CHANGE_STR, (WPARAM)iniData, 0);
	//edit color
	iniInt = GetPrivateProfileInt(prevSec, prevKeyEditClr, 0, iniPath);
	calcObj.mPrev.editRGB = (COLORREF)iniInt;
	lstrcpy(calcObj.mlpHexColor, GetRGBHex(hwnd, (COLORREF)iniInt));
	//back color
	iniInt = GetPrivateProfileInt(prevSec, prevKeyStaticClr, 0, iniPath);
	calcObj.mPrev.backRGB = (COLORREF)iniInt;
	//font color
	iniInt = GetPrivateProfileInt(prevSec, prevKeyFontClr, 0, iniPath);
	calcObj.mPrev.fontRGB = (COLORREF)iniInt;
	//font face
	GetPrivateProfileString(prevSec, prevKeyFontFace, TEXT(""), iniData, LF_FACESIZE, iniPath);
	lstrcpy(calcObj.mPrev.fontSty.lfFaceName, iniData);
	//font height
	calcObj.mPrev.fontSty.lfHeight = (LONG)GetPrivateProfileInt(prevSec, prevKeyFontHeight, 0, iniPath);
	//font option
	iniInt = GetPrivateProfileInt(prevSec, prevKeyFontOption, 0, iniPath);
	if (iniInt & 8) { calcObj.mPrev.fontSty.lfStrikeOut = TRUE; }
	if (iniInt & 4) { calcObj.mPrev.fontSty.lfUnderline = TRUE; }
	if (iniInt & 2) { calcObj.mPrev.fontSty.lfItalic    = TRUE; }
	if (iniInt & 1) { calcObj.mPrev.fontSty.lfWeight    = FW_BOLD; }
	//font charset
	calcObj.mPrev.fontSty.lfCharSet = (BYTE)GetPrivateProfileInt(prevSec, prevKeyFontCharset, SHIFTJIS_CHARSET, iniPath);

	//XV
	SendMessage(mdiObj.GetActChildHandle(), WM_APP_CHANGE_BACK, (WPARAM)calcObj.mPrev.backRGB, 0);
	SendMessage(mdiObj.GetActChildHandle(), WM_APP_CHANGE_RGB,  (WPARAM)&calcObj.mPrev, (LPARAM)&calcObj.mlpHexColor);
	SendMessage(mdiObj.GetActChildHandle(), WM_APP_CHANGE_FONT, (WPARAM)&calcObj.mPrev, 0);
	SetWindowPosLevel(hwnd);										//Oʕ\̍XV
	rgbObj.SetRGBtoCtrl(calcObj.mPrev.editRGB);	//RGBevf̍XV

	return true;
}

// EOF
