/* ====================================
		[eBeB
==================================== */
#include "stdafx.h"
#include "ClrChker.h"


/* ====================================
		`
==================================== */
//PathSpliter - ^ꂽpXtOɏ]ĕEĕԂ
//    return : opXւ̃|C^
//path : in  : pX̎oΏۂɂtpX
//flag : in  : 擾[htO  0="" | 1=ext | 2=title | 4=dir | 8=drive
LPTSTR CPathSpliter::GetSplitPath(LPTSTR path, int flag) {
	lstrcpy(fullPath, path);
#ifdef NO_VS
	_splitpath(fullPath, spltDrive, spltDir, spltTitle, spltExt);
#else
	_tsplitpath_s(fullPath, spltDrive, spltDir,	spltTitle, spltExt);
#endif
	if (flag & 8) {
		if (flag & 4) { lstrcat(spltDrive, spltDir);   }
		if (flag & 2) { lstrcat(spltDrive, spltTitle); }
		if (flag & 1) { lstrcat(spltDrive, spltExt);   }
		return spltDrive;
	}
	if (flag & 4) {
		if (flag & 2) { lstrcat(spltDir, spltTitle); }
		if (flag & 1) { lstrcat(spltDir, spltExt);   }
		return spltDir;
	}
	if (flag & 2) {
		if (flag & 1) { lstrcat(spltTitle, spltExt); }
		return spltTitle;
	}
	if (flag & 1) {
		return spltExt;
	} else {
		return TEXT("");
	}
}

//CErr - ނׂR\[̃nh擾
//return : R\[̃nh
HANDLE CErr::OpenConsole() {
#ifdef _DEBUG
	static HANDLE hConsole;		//L
	if (hConsole == NULL) {
		AllocConsole();
		SetConsoleCtrlHandler(NULL, TRUE);
		hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	}
	return hConsole;
#else
	return NULL;
#endif
}

//CErr - w蕶ƉsR\[ɏo͂
//lpstr : in  : ޕ
void CErr::Wrinteln(LPCTSTR lpstr) {
#ifdef _DEBUG
	HANDLE hConsole = this->OpenConsole();
	if (hConsole != INVALID_HANDLE_VALUE) {
		WriteConsole(hConsole, lpstr, lstrlen(lpstr), &this->dwWrite, NULL);
		WriteConsole(hConsole, TEXT("\n"), lstrlen(TEXT("\n")), &this->dwWrite, NULL);
	} else {
		MessageBox(NULL, TEXT("Open Console Failure!!"), TEXT("Wrinteln"), MB_ICONWARNING | MB_TOPMOST);
	}
#else
	UNREFERENCED_PARAMETER(lpstr);	//xԂ
#endif
}

//CErr - G[`FbNΕ\
CErr::CErr() {
#ifdef _DEBUG
	DWORD  errNum = GetLastError();
	if (errNum == NO_ERROR) { return; }

	LPVOID lpMsgBuf;
	HANDLE hConsole = this->OpenConsole();
	if (hConsole != INVALID_HANDLE_VALUE) {
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
									NULL, errNum, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, 0, NULL);
		wsprintf(this->str, TEXT("Error : (%d)%s"), errNum, lpMsgBuf);
	  WriteConsole(hConsole, this->str, lstrlen(this->str), &this->dwWrite, NULL);
		LocalFree(lpMsgBuf);
	} else {
		MessageBox(NULL, TEXT("Open Console Failure!!"), NULL, MB_ICONWARNING | MB_TOPMOST);
	}
#endif
}

//CErr - |C^^߂l\
CErr::CErr(void *pOut) {
#ifdef _DEBUG
	HANDLE hConsole = this->OpenConsole();
	if (hConsole != INVALID_HANDLE_VALUE) {
		wsprintf(this->str, TEXT("void *: 0x%08X\n"), pOut);
	  WriteConsole(hConsole, this->str, lstrlen(this->str), &this->dwWrite, NULL);
	} else {
		MessageBox(NULL, TEXT("Open Console Failure!!"), TEXT("void *"), MB_ICONWARNING | MB_TOPMOST);
	}
#else
	UNREFERENCED_PARAMETER(pOut);	//xԂ
#endif
}

//CErr - 萔^߂l\
CErr::CErr(int i) {
#ifdef _DEBUG
	HANDLE hConsole = this->OpenConsole();
	if (hConsole != INVALID_HANDLE_VALUE) {
		wsprintf(str, TEXT("int   : %10d\n"), i);
		WriteConsole(hConsole, this->str, lstrlen(this->str), &this->dwWrite, NULL);
	} else {
		MessageBox(NULL, TEXT("Open Console Failure!!"), TEXT("int"), MB_ICONWARNING | MB_TOPMOST);
	}
#else
	UNREFERENCED_PARAMETER(i);	//xԂ
#endif
}

// EOF
